﻿package utils
{
	public class XORRandom
	{
		private static const MAX_RATIO:Number = 1 / uint.MAX_VALUE;
		private static var r:uint = Math.random() * uint.MAX_VALUE;
        
		public static function randomRangeInt(min:int, max:int):int 
		{
			return int(random * (max - min + 1)) + min;
		}
        
        public static function randomRangeNumber(min:Number, max:Number):Number 
		{
			return random * (max - min) + min;
		}
        
		public static function get random():Number
		{
            r ^= (r << 21);
            r ^= (r >>> 35);
            r ^= (r << 4);
            return r * MAX_RATIO;
		}
	}
}